VSTGUI 4.10 Graphical User Interface Framework not only for VST plugins

Public Member Functions | List of all members
IWindow Class Referenceabstract
Standalone Library

Window interface. More...

`#include <iwindow.h>`

Inheritance diagram for IWindow:

## Public Member Functions
virtual const WindowControllerPtr & | getController () const =0
| Get the window controller. More...
virtual CPoint | getSize () const =0
| Get the size of the client area. More...
virtual CPoint | getPosition () const =0
| Get the position in global coordinates. More...
virtual double | getScaleFactor () const =0
| Get the content scale factor. More...
virtual CRect | getFocusViewRect () const =0
| Get the rect of the current focus view in frame relative coordinates. More...
virtual const UTF8String & | getTitle () const =0
| Get the title of the window. More...
virtual WindowType | getType () const =0
| Get the type of the window. More...
virtual WindowStyle | getStyle () const =0
| Get the style of the window. More...
virtual const UTF8String & | getAutoSaveFrameName () const =0
| Get the auto save frame name of the window. More...
virtual void | setSize (const CPoint &newSize)=0
| Set the size of the client area. More...
virtual void | setPosition (const CPoint &newPosition)=0
| Set the position in global coordinates. More...
virtual void | setTitle (const UTF8String &newTitle)=0
| Set the window title. More...
virtual void | setContentView (const SharedPointer< CFrame > &frame)=0
| Set content view. More...
virtual void | setRepresentedPath (const UTF8String &path)=0
| Set the path the contents of this window represents. More...
virtual WindowStyle | changeStyle (WindowStyle stylesToAdd, WindowStyle stylesToRemove)=0
| Change window style. More...
virtual void | show ()=0
| Show the window. More...
virtual void | hide ()=0
| Hide the window. More...
virtual void | close ()=0
| Close the window. More...
virtual void | activate ()=0
| Activate the window. More...
virtual void | registerWindowListener (IWindowListener *listener)=0
| Register a window listener. More...
virtual void | unregisterWindowListener (IWindowListener *listener)=0
| Unregister a window listener. More...
Public Member Functions inherited from Interface
virtual | ~Interface () noexcept
| Interface ()=default
| Interface (const Interface &)=delete
| Interface (Interface &&)=delete
Interface & | operator= (const Interface &)=delete
Interface & | operator= (Interface &&)=delete
template<typename T >
const auto | dynamicCast () const
template<typename T >
auto | dynamicCast ()

## Detailed Description

Window interface.

Windows are created via IApplication::instance ().createWindow ()

Windows are automatically destroyed when they are closed.

## Member Function Documentation

## ◆ activate()

virtual void activate | ( |  | ) |
| pure virtual

Activate the window.

## ◆ changeStyle()

virtual WindowStyle changeStyle | ( | WindowStyle | stylesToAdd,
|  | WindowStyle | stylesToRemove
| ) |  |
| pure virtual

Change window style.

May not change every style. Depends on the platform. Returns effective style.

## ◆ close()

virtual void close | ( |  | ) |
| pure virtual

Close the window.

## ◆ getAutoSaveFrameName()

virtual const UTF8String & getAutoSaveFrameName | ( |  | ) | const
| pure virtual

Get the auto save frame name of the window.

## ◆ getController()

virtual const WindowControllerPtr & getController | ( |  | ) | const
| pure virtual

Get the window controller.

Can be nullptr.

## ◆ getFocusViewRect()

virtual CRect getFocusViewRect | ( |  | ) | const
| pure virtual

Get the rect of the current focus view in frame relative coordinates.

## ◆ getPosition()

virtual CPoint getPosition | ( |  | ) | const
| pure virtual

Get the position in global coordinates.

## ◆ getScaleFactor()

virtual double getScaleFactor | ( |  | ) | const
| pure virtual

Get the content scale factor.

## ◆ getSize()

virtual CPoint getSize | ( |  | ) | const
| pure virtual

Get the size of the client area.

## ◆ getStyle()

virtual WindowStyle getStyle | ( |  | ) | const
| pure virtual

Get the style of the window.

## ◆ getTitle()

virtual const UTF8String & getTitle | ( |  | ) | const
| pure virtual

Get the title of the window.

## ◆ getType()

virtual WindowType getType | ( |  | ) | const
| pure virtual

Get the type of the window.

## ◆ hide()

virtual void hide | ( |  | ) |
| pure virtual

Hide the window.

## ◆ registerWindowListener()

virtual void registerWindowListener | ( | IWindowListener * | listener | ) |
| pure virtual

Register a window listener.

There is no ownership involved here, so you have to make sure the listener is alive as long as the window lives. Listeners are automatically removed when the window is closed.

## ◆ setContentView()

virtual void setContentView | ( | const SharedPointer< CFrame > & | frame | ) |
| pure virtual

Set content view.

## ◆ setPosition()

virtual void setPosition | ( | const CPoint & | newPosition | ) |
| pure virtual

Set the position in global coordinates.

## ◆ setRepresentedPath()

virtual void setRepresentedPath | ( | const UTF8String & | path | ) |
| pure virtual

Set the path the contents of this window represents.

## ◆ setSize()

virtual void setSize | ( | const CPoint & | newSize | ) |
| pure virtual

Set the size of the client area.

## ◆ setTitle()

virtual void setTitle | ( | const UTF8String & | newTitle | ) |
| pure virtual

Set the window title.

## ◆ show()

virtual void show | ( |  | ) |
| pure virtual

Show the window.

## ◆ unregisterWindowListener()

virtual void unregisterWindowListener | ( | IWindowListener * | listener | ) |
| pure virtual

Unregister a window listener.

The documentation for this class was generated from the following file:

- iwindow.h